"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MultiProccessTaskThrottle = void 0;
var _redisClient = require("./redisClient");
var _util = require("./util");
var _nodeSchedule = _interopRequireDefault(require("node-schedule"));
var _moment = _interopRequireDefault(require("moment"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw new Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw new Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, "catch": function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
var NODE_APP_INSTANCE = process.env.NODE_APP_INSTANCE || '-';
var __Do = function __Do(_ref) {
  var name = _ref.name,
    func = _ref.func,
    durationSecond = _ref.durationSecond,
    onError = _ref.onError;
  //name： 定制任务在redis中标记的key的名称
  //func：schedule模块调用的函数
  //durationSecond：预计执行的周期，在这个周期内，确保只有一个进程在处理逻辑。类似一个锁的机制，注意，这个时长不能超过schedule定时周期，并建议比定时周期少10秒中
  //onError：发生错误时的回调函数
  if (typeof func !== "function") throw new Error("\u6307\u5B9A\u7684func\u53C2\u6570\u4E0D\u662F\u6709\u6548\u7684function\u7C7B\u578B\uFF0C\u8BF7\u68C0\u67E5");
  return /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
    var taskNameInCacheKey, info_inside, __startTime, signal, re_signal, __endTime, refractory_period;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          console.log("[NODE_APP_INSTANCE=".concat(NODE_APP_INSTANCE, "] scheduleJob start >>>>>>>>").concat(new Date()));
          taskNameInCacheKey = name;
          _context.prev = 2;
          _context.next = 5;
          return (0, _redisClient.getRedisClient)().getAsync(taskNameInCacheKey);
        case 5:
          info_inside = _context.sent;
          if (info_inside) info_inside = JSON.parse(info_inside);
          if (info_inside) {
            _context.next = 36;
            break;
          }
          __startTime = new Date().getTime();
          signal = {
            status: 'doing',
            starttime: (0, _moment["default"])(),
            flowID: Math.random()
          }; //假设执行期是50秒，考虑进程奔溃或异常清空导致无法更新不应期。
          _context.t0 = console;
          _context.next = 13;
          return (0, _redisClient.getRedisClient)().setAsync(taskNameInCacheKey, JSON.stringify(signal), 'EX', durationSecond);
        case 13:
          _context.t1 = _context.sent;
          _context.t0.log.call(_context.t0, _context.t1);
          _context.next = 17;
          return (0, _util.sleep)(2000);
        case 17:
          _context.next = 19;
          return (0, _redisClient.getRedisClient)().getAsync(taskNameInCacheKey);
        case 19:
          re_signal = _context.sent;
          if (re_signal) re_signal = JSON.parse(re_signal);
          if (!(re_signal.flowID !== signal.flowID)) {
            _context.next = 24;
            break;
          }
          console.log("".concat(taskNameInCacheKey, "\u4EFB\u52A1\u9501\u62A2\u5360\u5931\u8D25\uFF0C\u4EA4\u7531\u522B\u4EBA\u6267\u884C\uFF0C\u4E2D\u65AD\uFF0C\u9000\u51FA\u4EFB\u52A1\uFF01"));
          //中断，退出
          return _context.abrupt("return");
        case 24:
          //执行任务
          console.log("".concat(taskNameInCacheKey, "\u4EFB\u52A1\u9501\u62A2\u5360\u6210\u529F\uFF0C\u8FDB\u5165\u6267\u884C\u72B6\u6001..."));
          _context.next = 27;
          return func();
        case 27:
          // 计算本周期内剩余的不应期时长，写入redis
          __endTime = new Date().getTime();
          refractory_period = Math.max(10, durationSecond - Math.floor((__endTime - __startTime) / 1000));
          console.log("\u4EFB\u52A1".concat(taskNameInCacheKey, "\u6267\u884C\u8017\u65F6\uFF1A").concat(__endTime - __startTime, "\u6BEB\u79D2\uFF0C\u5269\u4F59\u4E0D\u5E94\u671F\uFF1A").concat(refractory_period, "\u79D2"));
          //更改信号量
          signal.status = 'done';
          signal.expiretime = signal.starttime.add(durationSecond, 'second');
          //
          _context.next = 34;
          return (0, _redisClient.getRedisClient)().setAsync(taskNameInCacheKey, JSON.stringify(signal), 'EX', refractory_period);
        case 34:
          _context.next = 37;
          break;
        case 36:
          console.log("".concat(taskNameInCacheKey, "\u4EFB\u52A1\uFF0C\u522B\u4EBA\u5728\u6267\u884C\uFF0C\u6211\u8DF3\u8FC7..."));
        case 37:
          _context.next = 47;
          break;
        case 39:
          _context.prev = 39;
          _context.t2 = _context["catch"](2);
          if (!(typeof onError === "function")) {
            _context.next = 46;
            break;
          }
          _context.next = 44;
          return onError({
            name: name,
            func: func,
            durationSecond: durationSecond
          }, _context.t2);
        case 44:
          _context.next = 47;
          break;
        case 46:
          console.error(_context.t2);
        case 47:
        case "end":
          return _context.stop();
      }
    }, _callee, null, [[2, 39]]);
  }));
};

/**
 * cluster多线程环境下的定时任务执行器，内部带有互斥的锁机制，确保同一时间不会并发处理，依赖于redis来存储锁状态
 * @param schedulePlan  任务的执行周期/频率，内部传递给schedule.scheduleJob, 默认是每1分钟的第一秒开始执行一次（1 *\/1 * * * *）
 * @param name  任务的名称，唯一，也会用作在redis中保存的锁信息的key名称
 * @param func  回调函数
 * @param durationSecond    整体不应期，默认是50秒，计划任务循环周期必须大于此时间值
 * @param onError   捕获错误的自定义函数
 * @returns {Function}
 * @constructor
 */
var MultiProccessTaskThrottle = exports.MultiProccessTaskThrottle = function MultiProccessTaskThrottle(_ref3) {
  var _ref3$schedulePlan = _ref3.schedulePlan,
    schedulePlan = _ref3$schedulePlan === void 0 ? '1 */1 * * * *' : _ref3$schedulePlan,
    name = _ref3.name,
    func = _ref3.func,
    _ref3$durationSecond = _ref3.durationSecond,
    durationSecond = _ref3$durationSecond === void 0 ? 50 : _ref3$durationSecond,
    onError = _ref3.onError;
  var option = {
    name: name,
    func: func,
    durationSecond: durationSecond,
    onError: onError
  };
  return _nodeSchedule["default"].scheduleJob(schedulePlan, __Do(option));
};