"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withConvertAdminrules2MachineVersion = exports.uploadupdateCertList = exports.setting_CustomRuleValidator = exports.parseAdminAccountFromJWToken = exports.adminValidaterMiddleWare_HOC_HOC = exports.accessRule = void 0;
var _GKErrors_Inner = require("../class2api/GKErrors_Inner");
var _adminRuleValidator = _interopRequireDefault(require("./adminRuleValidator"));
var _loadConfig = _interopRequireDefault(require("./loadConfig.js"));
var _md = _interopRequireDefault(require("md5"));
var _isomorphicFetch = _interopRequireDefault(require("isomorphic-fetch"));
var _lodash = require("lodash");
var _adminJwtValidater = require("./adminJwtValidater");
var _excluded = ["req", "res", "__cacheManage", "___frontpageURL"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw new Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw new Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, "catch": function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
var _getConfig = (0, _loadConfig["default"])(),
  sysName = _getConfig.name,
  admin_rule_center = _getConfig.admin_rule_center;
var _ruleValidator_custom;
/**
 * 权证验证起
 * @param jwtoken
 * @param ruleCategory
 * @param ruleName
 * @param ruleDesc
 * @param codePath
 * @returns {Promise.<*>}
 */
var ruleValidator = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref) {
    var jwtoken, categoryName, categoryDesc, ruleName, ruleDesc, codePath, apiInvokeParams, frontReq, params;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          jwtoken = _ref.jwtoken, categoryName = _ref.categoryName, categoryDesc = _ref.categoryDesc, ruleName = _ref.ruleName, ruleDesc = _ref.ruleDesc, codePath = _ref.codePath, apiInvokeParams = _ref.apiInvokeParams, frontReq = _ref.frontReq;
          params = {
            jwtoken: jwtoken,
            categoryName: categoryName,
            categoryDesc: categoryDesc,
            ruleName: ruleName,
            ruleDesc: ruleDesc,
            codePath: codePath,
            apiInvokeParams: apiInvokeParams,
            frontReq: frontReq
          };
          if (!_ruleValidator_custom) {
            _context.next = 8;
            break;
          }
          _context.next = 5;
          return _ruleValidator_custom({
            sysName: sysName,
            jwtoken: jwtoken,
            categoryName: categoryName,
            categoryDesc: categoryDesc,
            ruleName: ruleName,
            ruleDesc: ruleDesc,
            codePath: codePath,
            frontReq: frontReq
          });
        case 5:
          return _context.abrupt("return", _context.sent);
        case 8:
          _context.next = 10;
          return _adminRuleValidator["default"]._ruleValidator_inner(_objectSpread(_objectSpread({}, params), {}, {
            sysName: sysName
          }));
        case 10:
          return _context.abrupt("return", _context.sent);
        case 11:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function ruleValidator(_x) {
    return _ref2.apply(this, arguments);
  };
}();

/**
 * accessRule访问权限修饰器中认证函数的全局配置入口
 *
 * @param ruleValidator
 */
var setting_CustomRuleValidator = exports.setting_CustomRuleValidator = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(ruleValidator) {
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          if (!(typeof ruleValidator !== "function")) {
            _context2.next = 2;
            break;
          }
          throw _GKErrors_Inner.GKErrors._PARAMS_VALUE_EXPECT("\u63D0\u4F9B\u7ED9setting_CustomRuleValidator\u7684\u53C2\u6570\u9700\u8981\u662FFunction\uFF0C\u800C\u4E0D\u662F".concat(_typeof(ruleValidator)));
        case 2:
          _ruleValidator_custom = ruleValidator;
        case 3:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
  return function setting_CustomRuleValidator(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

/**
 * 修饰器,提供访问权限的校验控制
 *
 * @returns {Function}
 */
var accessRule = exports.accessRule = function accessRule(options) {
  var categoryName = options.categoryName,
    ruleName = options.ruleName,
    _options$ruleDesc = options.ruleDesc,
    ruleDesc = _options$ruleDesc === void 0 ? '' : _options$ruleDesc;
  return function (target, name, descriptor) {
    //兼容babel 7的变化
    name = name || target.key;
    descriptor = descriptor || target.descriptor;

    // console.log( `accessRule:`  )
    // console.log( console.dir(target)  )
    // console.log( console.dir(name)  )
    // console.log( console.dir(descriptor)  )
    if (!ruleName) {
      //修饰器的报错，级别更高，直接抛出终止程序
      setTimeout(function () {
        throw new Error("\u5728\u7C7B\u9759\u6001\u65B9\u6CD5 ".concat(target.name, ".").concat(name, " \u4E0A\u6743\u9650\u63A7\u5236\u5668\u7684ruleName\u53C2\u6570\u672A\u5B9A\u4E49"));
      });
    }
    // console.log(`类静态方法 ${target.name}.${name}       上定义了权限点 =>      ${categoryName}.${ruleName} (${ruleDesc})`)

    var oldValue = descriptor.value;
    descriptor.value = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
      var Prod,
        hint,
        jwtoken,
        expressReq,
        apiModel,
        _arguments,
        _arguments$,
        apiParams0_Or_graphQLparent,
        graphQlparams,
        _arguments$2,
        ctx,
        info_nouse,
        req,
        request,
        apiInvokeParams,
        _expressReq,
        headers,
        cookies,
        frontReq,
        req_noused,
        res_noused,
        __cacheManage,
        ___frontpageURL_noused,
        _apiInvokeParams,
        _ref5,
        categoryName,
        categoryDesc,
        _yield$ruleValidator,
        err,
        result,
        canAccess,
        resean,
        _args3 = arguments;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            if (target.__modelSetting) {
              _context3.next = 3;
              break;
            }
            //修饰器的报错，级别更高，直接抛出终止程序
            setImmediate(function () {
              throw new Error("\u9700\u8981\u65B9\u6CD5\u7EA7\u6743\u9650\u7BA1\u63A7\u7684\u540E\u53F0\u4E1A\u52A1\u7C7B".concat(target.name, "\uFF0C\u8FD8\u6CA1\u6709\u6DFB\u52A0modelSetting\u4FEE\u9970\u5668"));
            });
            throw new Error("error in class2api");
          case 3:
            if (!(typeof target.__modelSetting !== "function")) {
              _context3.next = 6;
              break;
            }
            //修饰器的报错，级别更高，直接抛出终止程序
            setImmediate(function () {
              throw new Error("\u540E\u53F0\u4E1A\u52A1\u7C7B".concat(target.name, "\u6240\u6DFB\u52A0\u7684modelSetting\u4FEE\u9970\u5668\u4E0D\u6B63\u786E\uFF0C\u8BF7\u53C2\u8003class2api\u6587\u6863"));
            });
            throw new Error("error in class2api");
          case 6:
            if (target.__modelSetting().__ruleCategory) {
              _context3.next = 9;
              break;
            }
            //修饰器的报错，级别更高，直接抛出终止程序
            setImmediate(function () {
              throw new Error("\u7C7B ".concat(target.name, " \u7684modelSetting\u4FEE\u9970\u5668\u4E2D\u6CA1\u6709\u6307\u5B9A__ruleCategory\u5C5E\u6027\uFF08\u6743\u9650\u7EC4\u4FE1\u606F\uFF09"));
            });
            throw new Error("error in class2api");
          case 9:
            //优先取PRODUCTION_TYPE，其次取NODE_ENV
            Prod = process.env.PRODUCTION_TYPE || process.env.NODE_ENV;
            if (!(Prod !== "production")) {
              _context3.next = 16;
              break;
            }
            hint = "\u975E\u6B63\u5F0F\u73AF\u5883(PRODUCTION_TYPE=".concat(process.env.PRODUCTION_TYPE, ", NODE_ENV=").concat(process.env.NODE_ENV, ", nextJS\u9879\u76EE\u8BC6\u522BPRODUCTION_TYPE\uFF0CAPI\u9879\u76EE\u8BC6\u522BNODE_ENV)\uFF0C\u4FBF\u4E8E\u8C03\u8BD5\uFF0C\u6388\u6743\u653E\u884C...");
            console.error(hint);
            //直接放行调用
            _context3.next = 15;
            return oldValue.apply(void 0, _args3);
          case 15:
            return _context3.abrupt("return", _context3.sent);
          case 16:
            apiModel = 'api'; //传统class2api，还是prisma-graphQL接口API
            //取值位置1：传统API方法的入参
            //取值位置2：graphQL版API方法的入参
            //两个位置同时取
            _arguments = Array.prototype.slice.call(_args3), _arguments$ = _arguments[0], apiParams0_Or_graphQLparent = _arguments$ === void 0 ? {} : _arguments$, graphQlparams = _arguments[1], _arguments$2 = _arguments[2], ctx = _arguments$2 === void 0 ? {} : _arguments$2, info_nouse = _arguments[3];
            req = apiParams0_Or_graphQLparent.req;
            expressReq = req;
            if (!expressReq) {
              request = ctx.request;
              expressReq = request;
              if (expressReq) apiModel = 'graphQL';
            }
            if (expressReq) {
              _context3.next = 23;
              break;
            }
            throw _GKErrors_Inner.GKErrors._NOT_ACCESS_PERMISSION("\u8EAB\u4EFD\u65E0\u6CD5\u8BC6\u522B\uFF0C\u5728API\u5BF9\u5E94\u7684\u9759\u6001\u65B9\u6CD5(".concat(target.name, ".").concat(name, ")\u7684\u5165\u53C2\u4E2D\u672A\u8BFB\u53D6\u5230\u8BF7\u6C42\u5934\u5BF9\u8C61\u7684cookie.jwtoken\u6216headers['jwtoken']\uFF0C\u8BF7\u54A8\u8BE2class2api\u7684\u7EF4\u62A4\u4EBA\u5458"));
          case 23:
            jwtoken = expressReq.cookies.jwtoken || expressReq.headers['jwtoken'] || "";
            if (jwtoken) {
              _context3.next = 26;
              break;
            }
            throw _GKErrors_Inner.GKErrors._NOT_ACCESS_PERMISSION("\u8EAB\u4EFD\u672A\u660E\uFF0C\u60A8\u6CA1\u6709\u8BBF\u95EE".concat(target.name, ".").concat(name, "\u5BF9\u5E94API\u63A5\u53E3\u7684\u6743\u9650"));
          case 26:
            //采集请求的日志信息
            apiInvokeParams = '';
            _expressReq = expressReq, headers = _expressReq.headers, cookies = _expressReq.cookies;
            frontReq = {
              ___ip: expressReq.headers['x-forwarded-for'] || expressReq.connection && expressReq.connection.remoteAddress || expressReq.socket && expressReq.socket.remoteAddress || expressReq.connection.socket && expressReq.connection.socket.remoteAddress || '',
              headers: headers,
              cookies: cookies
            };
            if (apiModel === "api") {
              //剔除传统API请求参数中多余的（由框架注入的杂质信息），剩余属性为调用的真实入参
              req_noused = apiParams0_Or_graphQLparent.req, res_noused = apiParams0_Or_graphQLparent.res, __cacheManage = apiParams0_Or_graphQLparent.__cacheManage, ___frontpageURL_noused = apiParams0_Or_graphQLparent.___frontpageURL, _apiInvokeParams = _objectWithoutProperties(apiParams0_Or_graphQLparent, _excluded);
              try {
                apiInvokeParams = JSON.stringify(_apiInvokeParams);
              } catch (err) {
                apiInvokeParams = 'call params stringify error';
              }
            } else {
              try {
                apiInvokeParams = JSON.stringify(graphQlparams);
              } catch (err) {
                apiInvokeParams = 'call params stringify error（graphQL）';
              }
            }
            //长度过长，截取前505位
            if (apiInvokeParams.length > 505) {
              apiInvokeParams = apiInvokeParams.substr(0, 500) + '[...]';
            }
            _ref5 = target.__modelSetting ? target.__modelSetting().__ruleCategory : {
              name: '无名',
              desc: '-'
            }, categoryName = _ref5.name, categoryDesc = _ref5.desc;
            _context3.next = 34;
            return ruleValidator({
              jwtoken: jwtoken,
              categoryName: categoryName,
              categoryDesc: categoryDesc,
              ruleName: "".concat(ruleName),
              ruleDesc: ruleDesc,
              codePath: "".concat(target.name, ".").concat(name),
              apiInvokeParams: apiInvokeParams,
              frontReq: frontReq
            });
          case 34:
            _yield$ruleValidator = _context3.sent;
            err = _yield$ruleValidator.err;
            result = _yield$ruleValidator.result;
            canAccess = result.canAccess, resean = result.resean;
            if (canAccess) {
              _context3.next = 40;
              break;
            }
            throw _GKErrors_Inner.GKErrors._NOT_ACCESS_PERMISSION({
              resean: "\u8BBF\u95EE\u88AB\u62D2\u7EDD\uFF08\u529F\u80FD\uFF1A[".concat(categoryName, "/").concat(ruleName, "]\uFF0C\u4EE3\u7801:[").concat(target.name, ".").concat(name, "]\uFF0C\u539F\u56E0\uFF1A").concat(resean || '-', "\uFF09")
            });
          case 40:
            _context3.next = 42;
            return oldValue.apply(void 0, _args3);
          case 42:
            return _context3.abrupt("return", _context3.sent);
          case 43:
          case "end":
            return _context3.stop();
        }
      }, _callee3);
    }));
    return descriptor;
  };
};

/**
 * 从jstoken值解析后台管理用户的账号
 *
 * @param jstoken
 * @returns {Promise.<*>}
 */
var parseAdminAccountFromJWToken = exports.parseAdminAccountFromJWToken = /*#__PURE__*/function () {
  var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(_ref6) {
    var jwtoken, req;
    return _regeneratorRuntime().wrap(function _callee4$(_context4) {
      while (1) switch (_context4.prev = _context4.next) {
        case 0:
          jwtoken = _ref6.jwtoken, req = _ref6.req;
          _context4.next = 3;
          return _adminRuleValidator["default"].parseAdminAccountFromJWToken({
            jwtoken: jwtoken,
            req: req
          });
        case 3:
          return _context4.abrupt("return", _context4.sent);
        case 4:
        case "end":
          return _context4.stop();
      }
    }, _callee4);
  }));
  return function parseAdminAccountFromJWToken(_x3) {
    return _ref7.apply(this, arguments);
  };
}();

/**
 * 将易于书写结构中的rules value值转换为对象结构
 * @param adminrules
 * @returns {Promise<void>}
 */
var withConvertAdminrules2MachineVersion = exports.withConvertAdminrules2MachineVersion = function withConvertAdminrules2MachineVersion(adminrules) {
  if ((typeof window === "undefined" ? "undefined" : _typeof(window)) === "object") {
    throw new Error("\u5927\u524D\u7AEF\u73AF\u5883\uFF0C\u8BF7\u4F7F\u7528 nexweb\u7EC4\u4EF6\u4E2D\u7684withConvertAdminrules2MachineVersion\u51FD\u6570");
  }
  (0, _lodash.keys)(adminrules).forEach(function (CategoryKey) {
    var RuleItem = adminrules[CategoryKey];
    var sysName = RuleItem.__sysName;
    (0, _lodash.keys)(RuleItem).forEach(function (key2) {
      return RuleItem[key2] = {
        categoryName: CategoryKey,
        ruleName: key2,
        ruleDesc: RuleItem[key2],
        sysName: sysName
      };
    });
    RuleItem.__ruleCategory = {
      name: CategoryKey,
      desc: ''
    };
    delete RuleItem.__sysName;
  });
  return adminrules;
};
var uploadupdateCertList = exports.uploadupdateCertList = /*#__PURE__*/function () {
  var _ref9 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(_ref8) {
    var ruleCategory, ruleNameList, salt, timestamp, rawString, sign, res, _yield$res$json, err, result;
    return _regeneratorRuntime().wrap(function _callee5$(_context5) {
      while (1) switch (_context5.prev = _context5.next) {
        case 0:
          ruleCategory = _ref8.ruleCategory, ruleNameList = _ref8.ruleNameList, salt = _ref8.salt;
          if (ruleNameList) {
            _context5.next = 3;
            break;
          }
          throw _GKErrors_Inner.GKErrors._NOT_PARAMS("ruleNameList");
        case 3:
          if (ruleCategory) {
            _context5.next = 5;
            break;
          }
          throw _GKErrors_Inner.GKErrors._NOT_PARAMS("ruleCategory");
        case 5:
          //验证签名
          timestamp = new Date().getTime();
          rawString = JSON.stringify({
            ruleNameList: ruleNameList,
            ruleCategory: ruleCategory,
            from: name,
            timestamp: timestamp
          });
          sign = (0, _md["default"])("".concat(salt, "-").concat(rawString, "-").concat(process.env.NODE_ENV));
          _context5.prev = 8;
          _context5.next = 11;
          return (0, _isomorphicFetch["default"])(admin_rule_center.register, {
            method: 'post',
            rejectUnauthorized: false,
            headers: {
              'Accept': 'application/json, text/plain, */*',
              'Content-Type': 'application/json'
            },
            withCredentials: 'true',
            json: true,
            body: JSON.stringify({
              ruleNameList: ruleNameList,
              ruleCategory: ruleCategory,
              from: name,
              timestamp: timestamp,
              sign: sign
            })
          });
        case 11:
          res = _context5.sent;
          _context5.next = 14;
          return res.json();
        case 14:
          _yield$res$json = _context5.sent;
          err = _yield$res$json.err;
          result = _yield$res$json.result;
          return _context5.abrupt("return", {
            err: err,
            result: result
          });
        case 20:
          _context5.prev = 20;
          _context5.t0 = _context5["catch"](8);
          console.error("\u6743\u9650\u70B9\u6CE8\u518C\u9047\u5230\u9519\u8BEF");
          console.error(_context5.t0.stack);
        case 24:
        case "end":
          return _context5.stop();
      }
    }, _callee5, null, [[8, 20]]);
  }));
  return function uploadupdateCertList(_x4) {
    return _ref9.apply(this, arguments);
  };
}();
var adminValidaterMiddleWare_HOC_HOC = exports.adminValidaterMiddleWare_HOC_HOC = function adminValidaterMiddleWare_HOC_HOC(adminConsoleConfig) {
  return function (_ref10) {
    var categoryName = _ref10.categoryName,
      sysName = _ref10.sysName,
      ruleName = _ref10.ruleName;
    return function (req, res, next) {
      (0, _adminJwtValidater.jwtValidater)({
        categoryName: categoryName,
        sysName: sysName,
        ruleName: ruleName
      }, adminConsoleConfig, req, res).then(function (result) {
        if (result === true) {
          next();
        } else {
          //内部已经redirect到/noaccess提示页
        }
      })["catch"](function (e) {
        console.error(e.stack);
      });
    };
  };
};