"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _path = _interopRequireDefault(require("path"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
/*
 获取package中的系统名
 */
var load_package_name = function load_package_name() {
  var _require = require(_path["default"].join(process.cwd(), 'package.json')),
    _require$name = _require.name,
    name = _require$name === void 0 ? '' : _require$name;
  var applicationName = name.split(".")[0];
  console.log("\u540E\u53F0\u6743\u9650\u7BA1\u7406\u6A21\u5757\u4ECEpackage.json\u4E2D\u83B7\u53D6\u5F53\u524D\u4E1A\u52A1\u7CFB\u7EDF\u540D\uFF08\u53D6name.split(\".\")[0]\uFF09\uFF1A".concat(applicationName));
  if (!applicationName) throw new Error("\u4E1A\u52A1\u7CFB\u7EDF\u540D\u83B7\u53D6\u5931\u8D25\uFF0C\u6743\u9650\u7BA1\u7406\u8BA4\u8BC1\u5C06\u5931\u6548\uFF0C\u8BF7\u786E\u8BA4\u5B58\u5728package.json\u4E14\u5176\u4E2D\u5DF2\u914D\u7F6Ename\u5C5E\u6027");
  return applicationName;
};
var env = process.env.PRODUCTION_TYPE || process.env.NODE_ENV;
var prot = (typeof window === "undefined" ? "undefined" : _typeof(window)) === 'object' ? 'https:' : 'https:';
var default_domain = process.env.DEFAULT_DOMAIN || (env === 'production' ? "gankao.com" : "gankaotest2.com");
var urlpath = "//api.".concat(default_domain, "/api-rulecenter");
var validUrl = "".concat(prot).concat(urlpath);
console.log("\n\u6743\u9650\u8BA4\u8BC1\u4E2D\u5FC3admin_rule_center\u4E2D\u7684\u76F8\u5173\u63A5\u53E3\u5730\u5740\u7684\u4E3B\u57DF\u540D\uFF0C\u4F1A\u53D6\u73AF\u5883\u53D8\u91CFprocess.env.DEFAULT_DOMAIN(\u6CE8\u610F\u4E0D\u5E26\u4E8C\u7EA7\u57DF)\uFF0C\n\u5B9E\u9645\u8FD0\u884C\u65F6\u63A5\u53E3\u57DF\u540D\u4E3A 'api.' + DEFAULT_DOMAIN ,\u5F55\u5165api.gankao.com;\n\u5982\u7F3A\u7701\u5219\u6B63\u5F0F\u53D6gankao.com\u6216\u6D4B\u8BD5\u53D6gankaotest2.com;\n");
var class2api_config = {
  /**
   * 系统名称,默认读取package.json中的name
   */
  name: load_package_name(),
  /**
   * 权限认证中心
   */
  admin_rule_center: {
    /**
        * 用户身份验证接口
        */
    auth: validUrl + "/gkauth/authAdminAccount",
    /**
     * 权限验证接口
     */
    validator: validUrl + "/gkrulemanager/validate",
    /**
     * 权限配置表的注册接口
     */
    register: validUrl + "/gkrulemanager/updateCertList"
  }
};
try {
  var _require2 = require(_path["default"].join(process.cwd(), 'class2api.config.js')),
    customConfig = _require2.config;
  class2api_config = _objectSpread(_objectSpread({}, class2api_config), customConfig);
  console.log("\u540E\u53F0\u6743\u9650\u7BA1\u7406\u6A21\u5757\uFF1A\u53D1\u73B0class2api.config.js\u914D\u7F6E\uFF0C\u542F\u7528\u81EA\u5B9A\u4E49\u7684\u6743\u9650\u8BA4\u8BC1\u914D\u7F6E(".concat(env, ")\uFF1A").concat(JSON.stringify(class2api_config)));
} catch (err) {
  console.log("\u540E\u53F0\u6743\u9650\u7BA1\u7406\u6A21\u5757\uFF1A\u672A\u627E\u5230class2api.config.js\u914D\u7F6E\uFF0C\u542F\u7528\u5185\u7F6E\u7684\u6743\u9650\u8BA4\u8BC1\u914D\u7F6E(".concat(env, ")\uFF1A").concat(JSON.stringify(class2api_config)));
}
var _default = exports["default"] = function _default() {
  return _objectSpread({}, class2api_config);
};