"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CreateListenRouter = void 0;
var _express = _interopRequireWildcard(require("express"));
var _lodash = require("lodash");
var _url = _interopRequireDefault(require("url"));
var _jaegerClient = require("jaeger-client");
var _path = _interopRequireDefault(require("path"));
var _redisClient = require("./redisClient");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw new Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw new Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, "catch": function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
var router = new _express.Router();
var isDeveloping = process.env.NODE_ENV === 'development';
var alitracer;
var jaegerconfig;
var lastInvokeTime;
if (!isDeveloping) {
  var tag = process.env.PRODUCTION_TYPE === "production" ? "prod" : "test";
  jaegerconfig = {
    serviceName: function () {
      return require(_path["default"].join(process.cwd(), 'package.json')).name;
    }(),
    sampler: {
      type: "const",
      param: 1
    },
    reporter: {
      collectorEndpoint: "http://tracing-analysis-dc-hz-internal.aliyuncs.com/adapt_a5um63wkgi@21f512feeb00b10_a5um63wkgi@53df7ad2afe8301_".concat(tag, "/api/traces")
    }
  };
  alitracer = (0, _jaegerClient.initTracer)(jaegerconfig);
} else {
  console.warn('DEV开发环境，自动关闭阿里云链路跟踪（jaeger-client）');
}
var router_listen_created = false;

// let apiLimiter = new RateLimit({
//     windowMs: 15*60*1000, // 15 minutes
//     max: 1000,
//     statusCode:200,
//     delayMs: 0, // disabled,
//     handler:function (req, res, next) {
//         res.json({err: '请求过于频繁，请稍后重试', result:''})
//     }
// });
// {req,res,result}
var _bindRouter = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(BusinessModel, fn_beforeCall, fn_afterCall, frontpage_default) {
    var resWrap, result, _BusinessModel, _frontpage_default, router;
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          if (!fn_beforeCall) {
            _context3.next = 3;
            break;
          }
          if (!(typeof fn_beforeCall !== 'function')) {
            _context3.next = 3;
            break;
          }
          throw new Error('fn_beforeCall必须是function类型的参数');
        case 3:
          if (!fn_afterCall) {
            _context3.next = 6;
            break;
          }
          if (!(typeof fn_afterCall !== 'function')) {
            _context3.next = 6;
            break;
          }
          throw new Error('可选参数fn_afterCall必须是function类型的参数');
        case 6:
          resWrap = /*#__PURE__*/function () {
            var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref2) {
              var req, result;
              return _regeneratorRuntime().wrap(function _callee$(_context) {
                while (1) switch (_context.prev = _context.next) {
                  case 0:
                    req = _ref2.req, result = _ref2.result;
                    if (!fn_afterCall) {
                      _context.next = 7;
                      break;
                    }
                    _context.next = 4;
                    return fn_afterCall({
                      req: req,
                      result: result
                    });
                  case 4:
                    _context.t0 = _context.sent;
                    _context.next = 8;
                    break;
                  case 7:
                    _context.t0 = result;
                  case 8:
                    return _context.abrupt("return", _context.t0);
                  case 9:
                  case "end":
                    return _context.stop();
                }
              }, _callee);
            }));
            return function resWrap(_x5) {
              return _ref3.apply(this, arguments);
            };
          }();
          _BusinessModel = BusinessModel;
          _frontpage_default = frontpage_default;
          router = _express["default"].Router(); //开放get请求方式（注意：此时无法head传值）
          // router.get('*', async function (req, res, next) {
          //     res.json({err: 'get请求方式未实现, 仅限Post方式', result: null});
          // });
          router.all('*', /*#__PURE__*/function () {
            var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(req, res, next) {
              var pathItems, methodName, source, _source$queryObj, queryObj, params, paramsMerged, modelSetting, apipath, inner_result, _result, __redirected, __customResp, msg, retData;
              return _regeneratorRuntime().wrap(function _callee2$(_context2) {
                while (1) switch (_context2.prev = _context2.next) {
                  case 0:
                    _context2.prev = 0;
                    pathItems = req.path.split("/");
                    methodName = pathItems[1] ? pathItems[1] : null;
                    if (_BusinessModel[methodName]) {
                      _context2.next = 5;
                      break;
                    }
                    throw new Error("api\u8BF7\u6C42\u7684\u5730\u5740(".concat(req.originalUrl, ")\u4E2D\u5BF9\u5E94\u7684\u7C7B(").concat(_BusinessModel.name, ")\u4E0D\u5B58\u5728").concat(methodName, "\u65B9\u6CD5\uFF08\u8BBF\u95EE\u6765\u6E90\uFF1A").concat(req.get('referer'), "\uFF09,\u8BF7\u786E\u8BA4\u6620\u5C04\u7684\u7C7B\u662F\u5426\u6B63\u786E!"));
                  case 5:
                    if (!(!req.body && !res.query)) {
                      _context2.next = 7;
                      break;
                    }
                    throw new Error("api\u8BF7\u6C42\u4E2D\u7684body\u548Cquery\u90FD\u4E3A\u7A7A\uFF0C\u6CA1\u6709\u63D0\u4EA4\u5185\u5BB9\u4F20\u5165!");
                  case 7:
                    //queryObj是对早期传值方式的兼容（早期会将所有参数包裹在queryObj属性里）
                    source = req.method === 'POST' ? req.body : req.query;
                    _source$queryObj = source.queryObj, queryObj = _source$queryObj === void 0 ? source : _source$queryObj;
                    params = queryObj;
                    paramsMerged = null;
                    params.___frontpageURL = _url["default"].parse(req.headers['frontpage'] || _frontpage_default || '');
                    if (!(fn_beforeCall && typeof fn_beforeCall === 'function')) {
                      _context2.next = 25;
                      break;
                    }
                    //如果有要对传入参数做验证，则在fn_beforeCall中处理
                    modelSetting = _BusinessModel.__modelSetting ? _BusinessModel.__modelSetting() : {};
                    apipath = "".concat(_BusinessModel.name, ".").concat(req.path);
                    _context2.next = 17;
                    return fn_beforeCall({
                      apipath: apipath,
                      req: req,
                      res: res,
                      params: params,
                      modelSetting: modelSetting
                    });
                  case 17:
                    paramsMerged = _context2.sent;
                    if (!(paramsMerged && typeof paramsMerged === 'function')) {
                      _context2.next = 25;
                      break;
                    }
                    _context2.t0 = res;
                    _context2.next = 22;
                    return paramsMerged();
                  case 22:
                    _context2.t1 = _context2.sent;
                    _context2.t0.json.call(_context2.t0, _context2.t1);
                    return _context2.abrupt("return");
                  case 25:
                    _context2.next = 27;
                    return _BusinessModel[methodName](_objectSpread(_objectSpread({}, paramsMerged || params), {}, {
                      req: req,
                      res: res
                    }));
                  case 27:
                    result = _context2.sent;
                    if (!(typeof result === "function")) {
                      _context2.next = 40;
                      break;
                    }
                    inner_result = result();
                    if (!(_typeof(inner_result) === "object")) {
                      _context2.next = 38;
                      break;
                    }
                    _context2.t2 = res;
                    _context2.next = 34;
                    return resWrap({
                      req: req,
                      res: res,
                      result: inner_result
                    });
                  case 34:
                    _context2.t3 = _context2.sent;
                    _context2.t2.json.call(_context2.t2, _context2.t3);
                    _context2.next = 39;
                    break;
                  case 38:
                    res.end((inner_result || '').toString());
                  case 39:
                    return _context2.abrupt("return");
                  case 40:
                    if (!(_typeof(result) !== "object" || (0, _lodash.keys)(result).length === 0)) {
                      _context2.next = 42;
                      break;
                    }
                    throw new Error("\u63A5\u53E3\u8FD4\u56DE\u503C\u5FC5\u987B\u5305\u542Bkey\uFF0Fvalue\u7ED3\u6784\uFF08\u56E0\u6B64\u4E5F\u4E0D\u80FD\u4E3Anull\u503C\uFF09\uFF0C\u63A5\u53E3".concat(req.originalUrl, "\u7C7B\u7684").concat(methodName, "\u65B9\u6CD5\u8FD4\u56DE\u7684\u6570\u636E\u7ED3\u6784\u4E0D\u5177\u6709key/value\u7ED3\u6784\uFF0C\u8BF7\u9002\u914D\u8C03\u6574\u4EE5\u7B26\u5408\u89C4\u8303!"));
                  case 42:
                    //API方法内部做了重定向，或者自操作res输出
                    _result = result, __redirected = _result.__redirected, __customResp = _result.__customResp;
                    if (!(__redirected || __customResp)) {
                      _context2.next = 45;
                      break;
                    }
                    return _context2.abrupt("return");
                  case 45:
                    if (result) {
                      _context2.next = 50;
                      break;
                    }
                    msg = "\u63A5\u53E3\u8FD4\u56DE\u503C\u5FC5\u987B\u5305\u542Bkey\uFF0Fvalue\u7ED3\u6784\uFF08\u56E0\u6B64\u4E5F\u4E0D\u80FD\u4E3Anull\u503C\uFF09\uFF0C\u63A5\u53E3".concat(req.originalUrl, "\u7C7B\u7684").concat(methodName, "\u65B9\u6CD5\u8FD4\u56DE\u7684\u6570\u636E\u7ED3\u6784\u4E0D\u5177\u6709key/value\u7ED3\u6784\uFF0C\u8BF7\u9002\u914D\u8C03\u6574\u4EE5\u7B26\u5408\u89C4\u8303!");
                    console.error(msg);
                    if (!(process.env.NODE_ENV !== "production")) {
                      _context2.next = 50;
                      break;
                    }
                    throw new Error(msg);
                  case 50:
                    retData = {
                      err: null,
                      result: result
                    };
                    _context2.t4 = res;
                    _context2.next = 54;
                    return resWrap({
                      req: req,
                      res: res,
                      result: retData
                    });
                  case 54:
                    _context2.t5 = _context2.sent;
                    _context2.t4.json.call(_context2.t4, _context2.t5);
                    if (process.env.NODE_ENV !== "production" && process.env.PRINT_API_RESULT === "1") {
                      console.log("api call result from(".concat(req.originalUrl, "):").concat(JSON.stringifyline(retData)));
                    }
                    _context2.next = 75;
                    break;
                  case 59:
                    _context2.prev = 59;
                    _context2.t6 = _context2["catch"](0);
                    if (process.env.NODE_ENV !== "production") {
                      //region 让错误直接抛出，并终止程序。不需要时可以整体注释掉
                      // console.dir(`这里：除了程序逻辑级别的Exception错误，在非正式环境会终止程序，便于调试排查。不需要时可以找到我的位置并注释掉`);
                      // if (!err._gankao || process.env.StopOnAnyException == '1') {
                      //     //通过timeout排除错误，会导致程序终止
                      //     setTimeout(() => {
                      //         throw err;
                      //     });
                      // } else {
                      //     //程序逻辑级别的Exception，输出到控制台即可
                      // }
                      console.error(_context2.t6);
                      if (process.env.NODE_ENV !== "production") {
                        console.error(_context2.t6.stack);
                      }
                      //endregion
                    } else {
                      console.error(_context2.t6);
                    }
                    if (!(process.env.NODE_ENV !== "production")) {
                      _context2.next = 70;
                      break;
                    }
                    _context2.t7 = res;
                    _context2.next = 66;
                    return resWrap({
                      req: req,
                      res: res,
                      result: {
                        err: _objectSpread(_objectSpread({}, _context2.t6), {}, {
                          message: _context2.t6.message,
                          stack: _context2.t6.stack
                        }),
                        result: null
                      }
                    });
                  case 66:
                    _context2.t8 = _context2.sent;
                    _context2.t7.json.call(_context2.t7, _context2.t8);
                    _context2.next = 75;
                    break;
                  case 70:
                    _context2.t9 = res;
                    _context2.next = 73;
                    return resWrap({
                      req: req,
                      res: res,
                      result: {
                        err: _objectSpread(_objectSpread({}, _context2.t6), {}, {
                          message: _context2.t6.message
                        }),
                        result: null
                      }
                    });
                  case 73:
                    _context2.t10 = _context2.sent;
                    _context2.t9.json.call(_context2.t9, _context2.t10);
                  case 75:
                  case "end":
                    return _context2.stop();
                }
              }, _callee2, null, [[0, 59]]);
            }));
            return function (_x6, _x7, _x8) {
              return _ref4.apply(this, arguments);
            };
          }());
          return _context3.abrupt("return", router);
        case 12:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return function _bindRouter(_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();
var middle_gkAliTracer = function middle_gkAliTracer(req, res, next) {
  if (alitracer) {
    try {
      req.span = alitracer.startSpan(req.originalUrl);
      req.span.log({
        event: "timestamp",
        value: Date.now()
      });
    } catch (e) {
      console.error(e.stack);
    }
    next();
    try {
      req.span.finish();
    } catch (e) {
      console.error(e.stack);
    }
  } else {
    next();
  }
};
var CreateListenRouter = exports.CreateListenRouter = /*#__PURE__*/function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(options) {
    var lastVisit, apiroot, modelClasses, beforeCall, afterCall, method404, frontpage_default, _iterator, _step, classObj, model, as, aPath;
    return _regeneratorRuntime().wrap(function _callee6$(_context6) {
      while (1) switch (_context6.prev = _context6.next) {
        case 0:
          if (!router_listen_created) {
            _context6.next = 2;
            break;
          }
          return _context6.abrupt("return", router);
        case 2:
          lastVisit = new Date().getTime();
          apiroot = options.apiroot, modelClasses = options.modelClasses, beforeCall = options.beforeCall, afterCall = options.afterCall, method404 = options.method404, frontpage_default = options.frontpage_default;
          console.log('api root :', apiroot);
          router.use("*", function (req, res, next) {
            var _process$env = process.env,
              PRODUCTION_TYPE = _process$env.PRODUCTION_TYPE,
              GK_PREVIEW = _process$env.GK_PREVIEW;
            var val = PRODUCTION_TYPE;
            if (val === "production") {
              val = ~~GK_PREVIEW === 1 ? "production(preview)" : "production";
            }
            res.header("production-type", val);
            if (PRODUCTION_TYPE === "test") {
              if (new Date().getTime() - lastVisit > 1000 * 60) {
                lastVisit = new Date().getTime();
                setImmediate( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4() {
                  var app, red;
                  return _regeneratorRuntime().wrap(function _callee4$(_context4) {
                    while (1) switch (_context4.prev = _context4.next) {
                      case 0:
                        _context4.prev = 0;
                        app = (req.originalUrl || '').replace(/.*?\/((p|api)-.*?)\/.*/igm, "$1");
                        red = (0, _redisClient.getRedisClient)();
                        if (!red) {
                          _context4.next = 6;
                          break;
                        }
                        _context4.next = 6;
                        return (0, _redisClient.getRedisClient)().setAsyncOrig("sae-started-".concat(app), new Date().getTime() / 1000);
                      case 6:
                        _context4.next = 11;
                        break;
                      case 8:
                        _context4.prev = 8;
                        _context4.t0 = _context4["catch"](0);
                        console.error(_context4.t0.stack);
                      case 11:
                      case "end":
                        return _context4.stop();
                    }
                  }, _callee4, null, [[0, 8]]);
                })));
              }
            }
            next();
          });

          //router.use(apiLimiter);
          _iterator = _createForOfIteratorHelper(modelClasses);
          _context6.prev = 7;
          _iterator.s();
        case 9:
          if ((_step = _iterator.n()).done) {
            _context6.next = 38;
            break;
          }
          classObj = _step.value;
          if (!(typeof classObj === "function")) {
            _context6.next = 22;
            break;
          }
          _context6.t0 = router;
          _context6.t1 = "/".concat(classObj.name.toLowerCase());
          _context6.t2 = middle_gkAliTracer;
          _context6.next = 17;
          return _bindRouter(classObj, beforeCall, afterCall);
        case 17:
          _context6.t3 = _context6.sent;
          _context6.t0.use.call(_context6.t0, _context6.t1, _context6.t2, _context6.t3);
          console.log("mapped class '".concat(classObj.name, "' to '").concat(apiroot).concat(classObj.name.toLowerCase(), "/*' ... OK!"));
          _context6.next = 36;
          break;
        case 22:
          model = classObj.model, as = classObj.as;
          if (!(model && as)) {
            _context6.next = 35;
            break;
          }
          aPath = (as || model.name).toLowerCase();
          _context6.t4 = router;
          _context6.t5 = "/".concat(aPath);
          _context6.t6 = middle_gkAliTracer;
          _context6.next = 30;
          return _bindRouter(model, beforeCall, afterCall, frontpage_default);
        case 30:
          _context6.t7 = _context6.sent;
          _context6.t4.use.call(_context6.t4, _context6.t5, _context6.t6, _context6.t7);
          console.log("mapped class '".concat(model.name, "' to '").concat(apiroot).concat(aPath, "/*' ... OK!"));
          _context6.next = 36;
          break;
        case 35:
          throw new Error("modelClasses\u53C2\u6570\u4E2D".concat(classObj, "\u7684\u5BF9\u8C61\u4E0D\u662F\u6709\u6548\u7684Class\u7C7B\u6216{model,as}\u7ED3\u6784\u5B9A\u4E49"));
        case 36:
          _context6.next = 9;
          break;
        case 38:
          _context6.next = 43;
          break;
        case 40:
          _context6.prev = 40;
          _context6.t8 = _context6["catch"](7);
          _iterator.e(_context6.t8);
        case 43:
          _context6.prev = 43;
          _iterator.f();
          return _context6.finish(43);
        case 46:
          //API的存活探针
          router.all('/helloworld', function (req, res, next) {
            console.log('hello ... ');
            res.end('hello');
          });
          //API的存活探针
          router.all('/_hello', function (req, res, next) {
            console.log('hello ... ');
            res.end('hello');
          });

          //拦截未匹配到的其他方法
          router.all('*', /*#__PURE__*/function () {
            var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(req, res, next) {
              var retObj;
              return _regeneratorRuntime().wrap(function _callee5$(_context5) {
                while (1) switch (_context5.prev = _context5.next) {
                  case 0:
                    _context5.prev = 0;
                    if (!(typeof method404 === 'function')) {
                      _context5.next = 6;
                      break;
                    }
                    _context5.next = 4;
                    return method404(req, res);
                  case 4:
                    _context5.next = 7;
                    break;
                  case 6:
                    if (process.env.NODE_ENV === "production") {
                      res.status = 404;
                      res.json({
                        err: 'API Not Defined!',
                        result: null
                      });
                    } else {
                      retObj = {
                        err: "API\u65B9\u6CD5\u672A\u5B9A\u4E49(".concat(req.path, ", \u8BF7\u786E\u8BA4\u7C7B\u662F\u5426\u5B58\u5728\u6216\u7C7B\u7684\u540D\u79F0\u662F\u5426\u6709\u53D8\u66F4\uFF01)"),
                        result: null
                      };
                      console.error(JSON.stringify(retObj));
                      res.json(retObj);
                    }
                  case 7:
                    _context5.next = 13;
                    break;
                  case 9:
                    _context5.prev = 9;
                    _context5.t0 = _context5["catch"](0);
                    res.status = 404;
                    res.json({
                      err: "404\u5904\u7406\u9519\u8BEF(".concat(JSON.stringify(_context5.t0), ")"),
                      result: null
                    });
                  case 13:
                  case "end":
                    return _context5.stop();
                }
              }, _callee5, null, [[0, 9]]);
            }));
            return function (_x10, _x11, _x12) {
              return _ref7.apply(this, arguments);
            };
          }());
          router_listen_created = true;
          return _context6.abrupt("return", router);
        case 51:
        case "end":
          return _context6.stop();
      }
    }, _callee6, null, [[7, 40, 43, 46]]);
  }));
  return function CreateListenRouter(_x9) {
    return _ref5.apply(this, arguments);
  };
}();