"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _GKErrors_Inner = require("../class2api/GKErrors_Inner");
var _isomorphicFetch = _interopRequireDefault(require("isomorphic-fetch"));
var _loadConfig = _interopRequireDefault(require("./loadConfig.js"));
var _excluded = ["password"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw new Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw new Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, "catch": function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var _getConfig = (0, _loadConfig["default"])(),
  sysName = _getConfig.name,
  admin_rule_center = _getConfig.admin_rule_center;
var RuleValidator = /*#__PURE__*/function () {
  function RuleValidator() {
    _classCallCheck(this, RuleValidator);
    throw new Error('静态业务功能类无法实例化');
  }

  /**
   * 从jstoken值解析后台管理用户的账号
   *
   * @param jstoken
   * @returns {Promise.<*>}
   */
  //这里打开后会导致宿主项目运行启动错误，无解，暂时注释
  // @cacheAble({
  //     cacheKeyGene: ({jwtoken, req}) => {
  //         jwtoken = jwtoken || (req ? (req.header('jwtoken') || req.cookies.jwtoken) : '')
  //         return jwtoken;
  //     }
  // })
  _createClass(RuleValidator, null, [{
    key: "parseAdminAccountFromJWToken",
    value: function () {
      var _parseAdminAccountFromJWToken = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref) {
        var jwtoken, req, frontReq, res, _yield$res$json, err, result, _gankao, _ref2, password, restResult;
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              jwtoken = _ref.jwtoken, req = _ref.req;
              jwtoken = jwtoken || (req ? req.header('jwtoken') || req.cookies.jwtoken : '');
              if (jwtoken) {
                _context.next = 4;
                break;
              }
              throw _GKErrors_Inner.GKErrors._TOKEN_LOGIN_INVALID("\u6807\u8BB0\u8EAB\u4EFD\u9A8C\u8BC1\u7684jwtoken\u672A\u63D0\u4F9B");
            case 4:
              if (req) {
                //收集请求发起端的信息
                frontReq = {
                  ___ip: req.headers['x-forwarded-for'] || req.connection && req.connection.remoteAddress || req.socket && req.socket.remoteAddress || req.connection.socket && req.connection.socket.remoteAddress || '',
                  headers: req.headers,
                  cookies: req.cookies
                };
              }
              _context.next = 7;
              return (0, _isomorphicFetch["default"])(admin_rule_center.auth, {
                method: 'post',
                rejectUnauthorized: false,
                headers: {
                  'Accept': 'application/json, text/plain, */*',
                  'Content-Type': 'application/json',
                  'jwtoken': jwtoken
                },
                withCredentials: 'true',
                json: true,
                body: JSON.stringify({
                  nothing: 1,
                  frontReq: frontReq
                })
              });
            case 7:
              res = _context.sent;
              _context.next = 10;
              return res.json();
            case 10:
              _yield$res$json = _context.sent;
              err = _yield$res$json.err;
              result = _yield$res$json.result;
              if (!err) {
                _context.next = 20;
                break;
              }
              _gankao = err._gankao;
              if (!(_gankao === '1')) {
                _context.next = 19;
                break;
              }
              throw err;
            case 19:
              throw _GKErrors_Inner.GKErrors._TOKEN_LOGIN_INVALID("jwtoken\u65E0\u6CD5\u8BC6\u522B\uFF1A".concat(JSON.stringify(err)));
            case 20:
              if (process.env.PRODUCTION_TYPE !== "production") {
                console.log("admin_rule_center.auth post result = ".concat(JSON.stringify({
                  err: err,
                  result: result
                })));
              }
              //剔除密码
              _ref2 = result || {}, password = _ref2.password, restResult = _objectWithoutProperties(_ref2, _excluded);
              return _context.abrupt("return", restResult);
            case 23:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      function parseAdminAccountFromJWToken(_x) {
        return _parseAdminAccountFromJWToken.apply(this, arguments);
      }
      return parseAdminAccountFromJWToken;
    }() //这里打开后会导致宿主项目运行启动错误，无解，暂时注释
    // @cacheAble({
    //     cacheKeyGene: ({jwtoken = '', categoryName = '', ruleName = ''}) => {
    //         //以jwtoken、功能组名称、权限名称来组合索引，混存上一次的判断结果
    //         return jwtoken ? `_ruleValidator_inner-${hashcode(jwtoken)}-${hashcode(categoryName)}-${hashcode(ruleName)}` : '';
    //     }
    // })
  }, {
    key: "_ruleValidator_inner",
    value: function () {
      var _ruleValidator_inner2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(_ref3) {
        var sysName, jwtoken, categoryName, categoryDesc, ruleName, ruleDesc, codePath, _ref3$apiInvokeParams, apiInvokeParams, frontReq, res, text, jsonResult;
        return _regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              sysName = _ref3.sysName, jwtoken = _ref3.jwtoken, categoryName = _ref3.categoryName, categoryDesc = _ref3.categoryDesc, ruleName = _ref3.ruleName, ruleDesc = _ref3.ruleDesc, codePath = _ref3.codePath, _ref3$apiInvokeParams = _ref3.apiInvokeParams, apiInvokeParams = _ref3$apiInvokeParams === void 0 ? {} : _ref3$apiInvokeParams, frontReq = _ref3.frontReq;
              _context2.prev = 1;
              if (process.env.NODE_ENV !== "production") {
                console.log("\u6743\u9650,\u5411\u4E2D\u5FC3\u8BF7\u6C42\u6388\u6743\u8BA4\u8BC1(".concat(admin_rule_center.validator, "\uFF09..."));
              }
              _context2.next = 5;
              return (0, _isomorphicFetch["default"])(admin_rule_center.validator, {
                method: 'post',
                rejectUnauthorized: false,
                headers: {
                  'Accept': 'application/json, text/plain, */*',
                  'Content-Type': 'application/json',
                  'jwtoken': jwtoken
                },
                withCredentials: 'true',
                json: true,
                body: JSON.stringify({
                  sysName: sysName,
                  categoryName: categoryName,
                  categoryDesc: categoryDesc,
                  ruleName: ruleName,
                  ruleDesc: ruleDesc,
                  codePath: codePath,
                  apiInvokeParams: apiInvokeParams,
                  frontReq: frontReq
                })
              });
            case 5:
              res = _context2.sent;
              _context2.next = 8;
              return res.text();
            case 8:
              text = _context2.sent;
              if (process.env.NODE_ENV !== "production") {
                console.log("\u6743\u9650\uFF0C\u6388\u6743\u7ED3\u679C\u8FD4\u56DE\uFF1A");
                console.log(text);
              }
              _context2.prev = 10;
              jsonResult = JSON.parse(text);
              if (jsonResult.result && jsonResult.result.password) {
                delete jsonResult.result.password;
              }
              return _context2.abrupt("return", jsonResult);
            case 16:
              _context2.prev = 16;
              _context2.t0 = _context2["catch"](10);
              console.error("\u6743\u9650\uFF0C\u6388\u6743\u7ED3\u679C\u4E3A\u975Ejson\u683C\u5F0F\u7684\u5B57\u7B26\u4E32\uFF0C\u5C01\u88C5\u4E3A{err,result}\u63A5\u53E3...");
              console.error({
                err: null,
                result: text
              });
              return _context2.abrupt("return", {
                err: null,
                result: text
              });
            case 21:
              _context2.next = 33;
              break;
            case 23:
              _context2.prev = 23;
              _context2.t1 = _context2["catch"](1);
              if (!(process.env.NODE_ENV !== "production")) {
                _context2.next = 30;
                break;
              }
              console.error('调用权限认证接口时遇到程序错误，开发环境，将终止程序 ...');
              throw _context2.t1;
            case 30:
              console.error('调用权限认证接口时遇到程序错误，非开发环境，转换为GKErrors._RULE_VALIDATE_ERROR错误继续向下传递 ...');
              console.error(_context2.t1);
            case 32:
              throw _GKErrors_Inner.GKErrors._RULE_VALIDATE_ERROR(_context2.t1);
            case 33:
            case "end":
              return _context2.stop();
          }
        }, _callee2, null, [[1, 23], [10, 16]]);
      }));
      function _ruleValidator_inner(_x2) {
        return _ruleValidator_inner2.apply(this, arguments);
      }
      return _ruleValidator_inner;
    }()
  }]);
  return RuleValidator;
}();
var _default = exports["default"] = RuleValidator;