"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.vlog_setting = exports.vlogSend = void 0;
var _v = _interopRequireDefault(require("uuid/v4"));
var _VlogWorker = require("./VlogWorker.js");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw new Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw new Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, "catch": function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
var VlogWorker = __dirname + '/VlogWorker.js';
var _require = require('child_process'),
  fork = _require.fork;
var workerProcess;
var _apiUrl = '';
var _debugTrace = false;
var _secret;
var _sysName;
var start = function start() {
  workerProcess = fork(VlogWorker);
  workerProcess.on('close', function () {
    console.log("\u5B50\u8FDB\u7A0B\u610F\u5916\u7ED3\u675F\uFF0C\u6062\u590D\u8FD0\u884C ... ");
    console.dir(workerProcess);
    start();
  });
};
var vlog_setting = exports.vlog_setting = function vlog_setting(_ref) {
  var apiUrl = _ref.apiUrl,
    _ref$debugTrace = _ref.debugTrace,
    debugTrace = _ref$debugTrace === void 0 ? false : _ref$debugTrace,
    sysName = _ref.sysName,
    secret = _ref.secret;
  _apiUrl = apiUrl;
  _debugTrace = debugTrace;
  _sysName = sysName;
  _secret = secret;
  start();
};

/**
 * 发送日志
 * @param isProduction  是否为生产环境
 * @param sysName       业务方系统简称（二级域名的第一个单词缩写）
 * @param sourceHeaders 源请求req头
 * @param userIdentifier    用户标识
 * @param action            动作名称
 * @param targetType        操作目标
 * @param [time]            可选，动作事件的发生时间，默认为当前时间
 * @param targetID          操作目标的标识符
 * @param targetOwnerIdentifier 操作目标归属方的标识符
 * @param extraInfo         附加信息对象
 * @returns {Promise<void>}
 */
var vlogSend = exports.vlogSend = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref2) {
    var _ref2$isProduction, isProduction, sysName, sourceHeaders, userIdentifier, action, targetType, _ref2$time, time, targetID, targetOwnerIdentifier, extraInfo;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          _ref2$isProduction = _ref2.isProduction, isProduction = _ref2$isProduction === void 0 ? 1 : _ref2$isProduction, sysName = _ref2.sysName, sourceHeaders = _ref2.sourceHeaders, userIdentifier = _ref2.userIdentifier, action = _ref2.action, targetType = _ref2.targetType, _ref2$time = _ref2.time, time = _ref2$time === void 0 ? new Date() : _ref2$time, targetID = _ref2.targetID, targetOwnerIdentifier = _ref2.targetOwnerIdentifier, extraInfo = _ref2.extraInfo;
          if (_apiUrl) {
            _context.next = 3;
            break;
          }
          throw new Error("TransferVLog\u4E2D\u7684apiUrl\u5C1A\u672A\u914D\u7F6E\uFF0C\u8BF7\u5148\u8C03\u7528vlog_setting\u8BBE\u7F6E");
        case 3:
          if (_secret) {
            _context.next = 5;
            break;
          }
          throw new Error("TransferVLog\u4E2D\u7684secret\u5C1A\u672A\u914D\u7F6E\uFF0C\u8BF7\u5148\u8C03\u7528vlog_setting\u8BBE\u7F6E");
        case 5:
          if (_sysName) {
            _context.next = 7;
            break;
          }
          throw new Error("TransferVLog\u4E2D\u7684sysName\u5C1A\u672A\u914D\u7F6E\uFF0C\u8BF7\u5148\u8C03\u7528vlog_setting\u8BBE\u7F6E");
        case 7:
          if (!(typeof userIdentifier === "undefined" || typeof userIdentifier !== "string")) {
            _context.next = 9;
            break;
          }
          throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 userIdentifier \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662F\u5B57\u7B26\u4E32\u7C7B\u578B");
        case 9:
          if (!(typeof action === "undefined" || typeof action !== "string")) {
            _context.next = 11;
            break;
          }
          throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 action \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662F\u5B57\u7B26\u4E32\u7C7B\u578B");
        case 11:
          if (!(typeof targetType === "undefined" || typeof targetType !== "string")) {
            _context.next = 13;
            break;
          }
          throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 targetType \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662F\u5B57\u7B26\u4E32\u7C7B\u578B");
        case 13:
          if (!(typeof targetID === "undefined" || typeof targetID !== "string")) {
            _context.next = 15;
            break;
          }
          throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 targetID \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662F\u5B57\u7B26\u4E32\u7C7B\u578B");
        case 15:
          if (!(typeof time === "undefined" || typeof time !== "string")) {
            _context.next = 17;
            break;
          }
          throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 time \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662F\u5B57\u7B26\u4E32\u7C7B\u578B");
        case 17:
          if (!(_typeof(sourceHeaders) !== "object")) {
            _context.next = 19;
            break;
          }
          throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 sourceHeaders \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662Fobject\u7C7B\u578B");
        case 19:
          if (!(_typeof(extraInfo) !== "object")) {
            _context.next = 21;
            break;
          }
          throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 extraInfo \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662Fobject\u7C7B\u578B");
        case 21:
          if (_debugTrace) {
            console.log('vlogSend... ');
          }

          // workerProcess.send({
          _context.next = 24;
          return (0, _VlogWorker.doSendVlog)({
            _debugTrace: _debugTrace,
            _apiUrl: _apiUrl,
            _secret: _secret,
            _resendTimes: 0,
            //
            _uuid: (0, _v["default"])(),
            isProduction: isProduction === 1 || isProduction === '1' || isProduction === true ? 1 : 0,
            sysName: _sysName,
            userIdentifier: userIdentifier,
            action: action,
            targetType: targetType,
            targetID: targetID,
            time: time,
            targetOwnerIdentifier: targetOwnerIdentifier,
            extraInfo: extraInfo,
            sourceHeaders: sourceHeaders
          });
        case 24:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function vlogSend(_x) {
    return _ref3.apply(this, arguments);
  };
}();